//Leency 06.10.2011, Flood-it! v2.0, GPL

#include "lib\kolibri.h" 
#include "lib\random.h"
#include "lib\boxes.txt"
#include "lang.h--"


system_colors sc;
proc_info Form;

// 
char *BOARD_SIZES[]={ "S", "M", "L", 0 };
int DIFFICULTY_LEV_PARAMS[]={ 14, 19, 25};

							  
int BLOCKS_NUM = 14; //      Y

int BLOCKS_LEFT; // 


#define USER_PANEL_HEIGHT 35
#define BLOCK_SIZE 21 // 
#define MARKED 7
#define DELETED_BLOCK 6



#ifdef LANG_RUS
	char NEW_GAME_TEXT[]="  [F2]"; 
	char CLICKS_TEXT[]="⠫:";
#else
	char NEW_GAME_TEXT[]="New Game [F2]"; 
	char CLICKS_TEXT[]="  Blocks:";
#endif


int blocks_matrix[28*28]; //    


void main()
{   
	int key, id;
	
	new_game();
   
	loop()
	{
		switch(WaitEvent()) 
		{
			case evButton:
				id = GetButtonID(); 
				if (id==1) ExitProcess();
				if (id==2) goto _NEW_GAME_MARK;
				if (id>=100)
				{
					//if (blocks_matrix[0]==id-100) break; //     ,   
					//if (CLICKS>=MAX_CLICKS) break; //  
					
					move_blocks(id-100);
					draw_field();
					
					draw_clicks_num();
					
					check_for_end(); //  
					break;
				}
				if (id>=10) //  
				{
					id=id-10;
					
					if (BLOCKS_NUM == DIFFICULTY_LEV_PARAMS[id]) break; //   
					
					BLOCKS_NUM = DIFFICULTY_LEV_PARAMS[id]; //      Y
					
					new_game();
					
					MoveSize(-1, -1, BLOCK_SIZE*BLOCKS_NUM +9, BLOCK_SIZE*BLOCKS_NUM +GetSkinWidth()+4+USER_PANEL_HEIGHT);
					break;
				}
				break;
			case evKey:
				key = GetKey();
				if (key==027) //Escape
					 ExitProcess();
				if (key==051) //F2
				{
					_NEW_GAME_MARK:
						new_game();
						draw_clicks_num();
						draw_field();
				}
				break;
			case evReDraw:
				draw_window();
		}
	}
}


void move_blocks(int button_id) //  ,   
{
	int i=0, j=0,
	old_color_id=blocks_matrix[button_id],
	restart;

	
	blocks_matrix[button_id]=MARKED;

	//     
	_RESTART_MARK:
	restart=0;
	for (i=0;i<BLOCKS_NUM;i++)
		for (j=0;j<BLOCKS_NUM;j++)
		{
			if (blocks_matrix[i*BLOCKS_NUM+j]<>old_color_id) continue; //      
			if (blocks_matrix[i*BLOCKS_NUM+j]==MARKED) continue; //   ,  
			
			if (j>0) && (blocks_matrix[i*BLOCKS_NUM+j-1]==MARKED) blocks_matrix[i*BLOCKS_NUM+j]=MARKED; // 
			if (i>0) && (blocks_matrix[i-1*BLOCKS_NUM+j]==MARKED) blocks_matrix[i*BLOCKS_NUM+j]=MARKED; // 
			if (j<BLOCKS_NUM-1) && (blocks_matrix[i*BLOCKS_NUM+j+1]==MARKED) blocks_matrix[i*BLOCKS_NUM+j]=MARKED; // 
			if (i<BLOCKS_NUM-1) && (blocks_matrix[i+1*BLOCKS_NUM+j]==MARKED) blocks_matrix[i*BLOCKS_NUM+j]=MARKED; // 
			
			if (blocks_matrix[i*BLOCKS_NUM+j]==MARKED) restart=1; //  ,        -    
		}
	if (restart) goto _RESTART_MARK;

	//   
	_2_RESTART_MARK:
	restart=0;
	for (i=BLOCKS_NUM;i>0;i--)
		for (j=BLOCKS_NUM;j>=0;j--)
		{
			if (blocks_matrix[i*BLOCKS_NUM+j]==MARKED) && (blocks_matrix[i-1*BLOCKS_NUM+j]<>blocks_matrix[i*BLOCKS_NUM+j])
			{
				blocks_matrix[i*BLOCKS_NUM+j]><blocks_matrix[i-1*BLOCKS_NUM+j];
				restart=1;
			}
		}
	if (restart) goto _2_RESTART_MARK;
	
	// ,  
	for (i=0;i<BLOCKS_NUM*BLOCKS_NUM;i++) 
			if (blocks_matrix[i]==MARKED)
				blocks_matrix[i]=DELETED_BLOCK;
				
	//  ,    
	restart=BLOCKS_NUM; //    :(
	
	_3_RESTART_MARK:
	for (j=0;j<BLOCKS_NUM-1;j++)
		if (blocks_matrix[BLOCKS_NUM-1*BLOCKS_NUM+j]==DELETED_BLOCK)
		{
			for (i=0;i<BLOCKS_NUM;i++)
				blocks_matrix[i*BLOCKS_NUM+j]><blocks_matrix[i*BLOCKS_NUM+j+1];
		}
	restart--;
	if (restart) goto _3_RESTART_MARK;
	
}




void draw_window()
{
	int j, ON_Y;
	
	sc.get();
	DefineAndDrawWindow(300,176, BLOCK_SIZE*BLOCKS_NUM +9, BLOCK_SIZE*BLOCKS_NUM +GetSkinWidth()+4+USER_PANEL_HEIGHT, 0x74,sc.work,0,0,"Flood-it!"); 
	
	//      
	GetProcessInfo(#Form, SelfInfo);
	if (Form.height==GetSkinWidth()+3) return;



	ON_Y=BLOCK_SIZE*BLOCKS_NUM;

	DrawBar(0,ON_Y, ON_Y, USER_PANEL_HEIGHT, sc.work); // 
		
	// 
	DefineButton(10,ON_Y+7, 13*6+6, 20, 2,sc.work_button);
	WriteText(10+4,ON_Y+14,0x80,sc.work_button_text,#NEW_GAME_TEXT,0);


	//   
	for (j=0;BOARD_SIZES[j]<>0;j++)
	{
		DefineButton(j*25+200,ON_Y+7, 20,20, j+10,sc.work_button);
		
		if (BLOCKS_NUM == DIFFICULTY_LEV_PARAMS[j]) EDI=0x800080;
			else EDI=sc.work_button_text;
		
		WriteText(j*25+200+8,ON_Y+14,0x80,EDI,BOARD_SIZES[j],0);
		WriteText(j*25+200+9,ON_Y+14,0x80,EDI,BOARD_SIZES[j],0);
	}
	
	draw_clicks_num();
	
	draw_field();

}



void draw_clicks_num()
{
	int TEXT_X=110;
	int TEXT_Y=BLOCK_SIZE*BLOCKS_NUM+14;

	int i;
	BLOCKS_LEFT=0;
	
	for (i=0;i<BLOCKS_NUM*BLOCKS_NUM;i++) 
		if (blocks_matrix[i]<>DELETED_BLOCK) BLOCKS_LEFT++;	
	
	DrawBar(10*6+TEXT_X, TEXT_Y, 6*4,9, sc.work);
	
	WriteText(TEXT_X,TEXT_Y,0x80,sc.work_text,#CLICKS_TEXT,0);

	if (BLOCKS_LEFT<10) EBX=11*6+TEXT_X;
		else EBX=10*6+TEXT_X;
	
	WriteText(EBX,TEXT_Y,0x80,sc.work_text,IntToStr(BLOCKS_LEFT),0);
	
}


void new_game()
{
	int i;
	
	//      ,   ()  ,
	//      - , 6
	for (i=0;i<BLOCKS_NUM*BLOCKS_NUM;i++)
		blocks_matrix[i] = random(5);
}

int check_for_end()
{
	int i, j, button_id;

	if (!BLOCKS_LEFT)
	{
		WriteDebug("");
		WriteDebug("You win!");
		WriteDebug("There is no blocks!");
		return 1;
	}

	for (i=0;i<BLOCKS_NUM;i++)
		for (j=0;j<BLOCKS_NUM;j++)
		{
			button_id=blocks_matrix[i*BLOCKS_NUM+j];
			
			if (button_id==DELETED_BLOCK) continue;
			
			if (j>0) && (blocks_matrix[i*BLOCKS_NUM+j-1]==button_id) return 0;
			if (i>0) && (blocks_matrix[i-1*BLOCKS_NUM+j]==button_id) return 0;
			if (j<BLOCKS_NUM-1) && (blocks_matrix[i*BLOCKS_NUM+j+1]==button_id) return 0;
			if (i<BLOCKS_NUM-1) && (blocks_matrix[i+1*BLOCKS_NUM+j]==button_id) return 0;
		}

	WriteDebug("");
	WriteDebug("The end. Rezult:");
	WriteDebug(IntToStr(BLOCKS_LEFT));
	return 2;
}

void draw_field()
{
	int i, j;
	int current_id;
	
	for (i=0;i<BLOCKS_NUM;i++)
		for (j=0;j<BLOCKS_NUM;j++)
		{
			current_id = i*BLOCKS_NUM+j;
			if (blocks_matrix[current_id]==DELETED_BLOCK)
			{
				DrawBar(j*BLOCK_SIZE,i*BLOCK_SIZE, BLOCK_SIZE,BLOCK_SIZE, 0xB2B4BF);
				DeleteButton(current_id+100);
			}
			else
			{
				DefineButton(j*BLOCK_SIZE,i*BLOCK_SIZE,BLOCK_SIZE-1,BLOCK_SIZE-1, current_id+100+BT_HIDE,0);
				PutImage(blocks_matrix[current_id]*1323+#img,21,21,j*BLOCK_SIZE,i*BLOCK_SIZE);
			}
		}
}


stop: